/*** SSI.C ***/

FILE *arq;

float ksi = 0.03;
long quant_pontos = 0;

/* ----------------------------------------------------------------------- */

typedef struct {
  float x, y;
} ponto;

#define QUANT_MAX_PONTOS 2000
ponto P[QUANT_MAX_PONTOS];

/* ----------------------------------------------------------------------- */

int HouveErro = 0;

void Erro(void) {
  HouveErro = 1;
}

#define SPONTOINICIAL -1
#define SPROXIMOPONTO -2
#define FORAINTERVALO -3
#define PONTOREPETIDO -4
#define VETORTANGENTE -5
#define PONTOSDEMAIS  -6
#define OVERFLOW      -7

/* ----------------------------------------------------------------------- */

void MensagemErro(int n) {
  if (n == SPONTOINICIAL)
    fprintf(arq, "\nERRO: nao foi possivel encontrar ponto inicial da intersecao");
  else if (n == SPROXIMOPONTO)
    fprintf(arq, "\nERRO: nao foi possivel encontrar proximo ponto na intersecao");
  else if (n == FORAINTERVALO)
    fprintf(arq, "\nERRO: ponto fora do intervalo");
  else if (n == PONTOREPETIDO)
    fprintf(arq, "\nERRO: ponto repetido");
  else if (n == VETORTANGENTE)
    fprintf(arq, "\nERRO: vetor tangente nulo");
  else if (n == PONTOSDEMAIS)
    fprintf(arq, "\nERRO: pontos acima da quantidade esperada");
  else if (n == OVERFLOW)
    fprintf(arq, "\nERRO: overflow, etc.");
  fflush(arq);
  HouveErro = 0;
}

unsigned quantidade_de_pontos = 0;

/* ----------------------------------------------------------------------- */

int IncluiPonto(float X, float Y) {

  unsigned i;
  const float epsilon = 1e-6;

  for (i = 0; i < quantidade_de_pontos; i++)
    if (fabs(X - P[i].x) < epsilon && fabs(Y - P[i].y) < epsilon) return 0;
  P[quantidade_de_pontos].x = X;
  P[quantidade_de_pontos].y = Y;
  quantidade_de_pontos++;
  return 1;
}

/* ----------------------------------------------------------------------- */

/* Calcula (V1, V2, V3) o produto vetorial dos vetores (a1, a2, a3) e
   (b1, b2, b3) */

#define PROD_VET(V1, V2, V3, a1, a2, a3, b1, b2, b3) V1 = a2*b3-a3*b2; \
				   V2 = a3*b1-a1*b3; V3 = a1*b2-a2*b1

/* ----------------------------------------------------------------------- */

/* Calcula a norma do vetor (V1, V2, V3) */

#define NORMA(V1, V2, V3)  (sqrt((V1)*(V1) + (V2)*(V2) + (V3)*(V3)))

/* ----------------------------------------------------------------------- */
/*
int VetorTangente(float *T0, float *T1, float *T2, float (*f1)(float, float),
		   float (*f2)(float, float), float (*f3)(float, float),
		   float u1, float v1,
		   float (*g1)(float, float), float (*g2)(float, float),
		   float (*g3)(float, float), float u2, float v2,
		   float Norma) {

/* Calcula (*T0, *T1, *T2) o vetor tangente `a curva intersecao das
   superficies f(u, v) = (f1(u, v), f2(u, v), f3(u, v))  e
	       g(u, v) = (g1(u, v), g2(u, v), g3(u, v))          */

  const float h = 1E-6;
  float a1, a2, a3, b1, b2, b3, c1, c2, c3, d1, d2, d3,
	F_n1, F_n2, F_n3, G_n1, G_n2, G_n3, norma_T;
  const float epsilon = 1e-6;

  /* Calculo de 2 vetores tangentes `a superficie f */

  a1 = (f1(u1 + h, v1) - f1(u1 - h, v1))/(2.0*h);
  a2 = (f2(u1 + h, v1) - f2(u1 - h, v1))/(2.0*h);
  a3 = (f3(u1 + h, v1) - f3(u1 - h, v1))/(2.0*h);

  b1 = (f1(u1, v1 + h) - f1(u1, v1 - h))/(2.0*h);
  b2 = (f2(u1, v1 + h) - f2(u1, v1 - h))/(2.0*h);
  b3 = (f3(u1, v1 + h) - f3(u1, v1 - h))/(2.0*h);

  /* Calculo de 2 vetores tangentes `a superficie g */

  c1 = (g1(u2 + h, v2) - g1(u2 - h, v2))/(2.0*h);
  c2 = (g2(u2 + h, v2) - g2(u2 - h, v2))/(2.0*h);
  c3 = (g3(u2 + h, v2) - g3(u2 - h, v2))/(2.0*h);

  d1 = (g1(u2, v2 + h) - g1(u2, v2 - h))/(2.0*h);
  d2 = (g2(u2, v2 + h) - g2(u2, v2 - h))/(2.0*h);
  d3 = (g3(u2, v2 + h) - g3(u2, v2 - h))/(2.0*h);

  /* Vetor normal a f */
  PROD_VET(F_n1, F_n2, F_n3, a1, a2, a3, b1, b2, b3);

  /* Vetor normal a g */
  PROD_VET(G_n1, G_n2, G_n3, c1, c2, c3, d1, d2, d3);

  /* Vetor tangente `a intersecao */
  PROD_VET(*T0, *T1, *T2, F_n1, F_n2, F_n3, G_n1, G_n2, G_n3);

  norma_T = NORMA(*T0, *T1, *T2);
  if (norma_T < epsilon) return 0;

  *T0 *= Norma/norma_T;
  *T1 *= Norma/norma_T;
  *T2 *= Norma/norma_T;

  return 1;
}
  */
/* ----------------------------------------------------------------------- */

#define DET(a, b, c, d, e, f, g, h, i)  ((a)*(e)*(i)+(c)*(d)*(h)+(b)*(f)*(g)\
				       -(c)*(e)*(g)-(a)*(f)*(h)-(b)*(d)*(i))

/* ----------------------------------------------------------------------- */

int ResolveSistema3x3(float A, float B, float C, float M,
		    float D, float E, float F, float N,
		    float G, float H, float I, float P,
		    float *X, float *Y, float *Z) {

  float Det;
  const float erro = 1E-10;

  Det = DET(A, B, C, D, E, F, G, H, I);
  if (fabs(Det) < erro) return 0;
  *X = DET(M, B, C, N, E, F, P, H, I)/Det;
  *Y = DET(A, M, C, D, N, F, G, P, I)/Det;
  *Z = DET(A, B, M, D, E, N, G, H, P)/Det;
  return 1;
}

/* ----------------------------------------------------------------------- */

int ResolveSistema3x4(float A, float B, float C, float D, float E,
		      float F, float G, float H, float I, float J,
		      float K, float L, float M, float N, float O,
		      float *X1, float *Y1, float *Z1, float *W1,
		      float *X2, float *Y2, float *Z2, float *W2) {

  float x2, y2, z2;

  if (!ResolveSistema3x3(A, B, C, E, F, G, H, J, K, L, M, O, X1, Y1, Z1))
    return 0;
  *W1 = 0;
  if (!ResolveSistema3x3(A, B, C, E - D, F, G, H, J - I, K, L, M, O - N,
    &x2, &y2, &z2)) return 0;
  *X2 = x2 - *X1;
  *Y2 = y2 - *Y1;
  *Z2 = z2 - *Z1;
  *W2 = 1;

  return 1;
}

/* ----------------------------------------------------------------------- */

int CalculaA0B0(float (*f1)(float,float), float (*f2)(float,float),
  float (*f3)(float,float), float x0, float y0,  float (*g1)(float,float),
  float (*g2)(float,float), float (*g3)(float,float),  float x1, float y1,
			       float *X1, float *Y1, float *Z1, float *W1,
			       float *X2, float *Y2, float *Z2, float *W2) {

  const float H = 1E-6;
  float a, b, c, d, e, f, g, h, i, j, k, l, m, n, o;

  a = (f1(x0 + H, y0) - f1(x0 - H, y0))/(2.0*H);
  b = (f1(x0, y0 + H) - f1(x0, y0 - H))/(2.0*H);
  c = (f2(x0 + H, y0) - f2(x0 - H, y0))/(2.0*H);
  d = (f2(x0, y0 + H) - f2(x0, y0 - H))/(2.0*H);
  e = (f3(x0 + H, y0) - f3(x0 - H, y0))/(2.0*H);
  f = (f3(x0, y0 + H) - f3(x0, y0 - H))/(2.0*H);

  g = (g1(x1 + H, y1) - g1(x1 - H, y1))/(2.0*H);
  h = (g1(x1, y1 + H) - g1(x1, y1 - H))/(2.0*H);
  i = (g2(x1 + H, y1) - g2(x1 - H, y1))/(2.0*H);
  j = (g2(x1, y1 + H) - g2(x1, y1 - H))/(2.0*H);
  k = (g3(x1 + H, y1) - g3(x1 - H, y1))/(2.0*H);
  l = (g3(x1, y1 + H) - g3(x1, y1 - H))/(2.0*H);

  m = a*x0 + b*y0 - g*x1 - h*y1 + g1(x1, y1) - f1(x0, y0);
  n = c*x0 + d*y0 - i*x1 - j*y1 + g2(x1, y1) - f2(x0, y0);
  o = e*x0 + f*y0 - k*x1 - l*y1 + g3(x1, y1) - f3(x0, y0);

  return ResolveSistema3x4(a, b, -g, -h, m,
			   c, d, -i, -j, n,
			   e, f, -k, -l, o,
			   X1, Y1, Z1, W1, X2, Y2, Z2, W2);
}

/* ----------------------------------------------------------------------- */

int FiInversa(float (*f1)(float, float), float (*f2)(float, float),
	      float (*f3)(float, float), float x0, float y0,
	      float A, float B, float C, float *x, float *y) {

/*
   Calcula o Fi inverso de (A, B, C), resolvendo o sistema linear

	     (*x) a + (*y) b = A - f1(x0, y0) + a x0 + b y0
	     (*x) c + (*y) d = B - f2(x0, y0) + c x0 + d y0
	     (*x) e + (*y) f = C - f3(x0, y0) + e x0 + f y0

   onde {{a, b}, {c, d}, {e, f}} e' a matriz jacobiana de f em (x0, y0).
*/

  const float epsilon = 1e-6, H = 1e-6;
  float a, b, c, d, e, f, determinante;

  a = (f1(x0 + H, y0) - f1(x0 - H, y0))/(2.0*H);
  b = (f1(x0, y0 + H) - f1(x0, y0 - H))/(2.0*H);
  c = (f2(x0 + H, y0) - f2(x0 - H, y0))/(2.0*H);
  d = (f2(x0, y0 + H) - f2(x0, y0 - H))/(2.0*H);
  e = (f3(x0 + H, y0) - f3(x0 - H, y0))/(2.0*H);
  f = (f3(x0, y0 + H) - f3(x0, y0 - H))/(2.0*H);

  determinante = a*d - b*c;
  if (fabs(determinante) > epsilon) {
    *x = ((A-f1(x0,y0)+a*x0+b*y0)*d - (B-f2(x0,y0)+c*x0+d*y0)*b)/determinante;
    *y = ((B-f2(x0,y0)+c*x0+d*y0)*a - (A-f1(x0,y0)+a*x0+b*y0)*c)/determinante;
    if (fabs((*x)*e + (*y)*f + f3(x0, y0) - C - e*x0 - f*y0) < epsilon)
      return 1;
  }
  else
  {
    determinante = a*f - e*b;
    if (fabs(determinante) > epsilon) {
      *x = ((A-f1(x0,y0)+a*x0+b*y0)*f - (C-f3(x0,y0)+e*x0+f*y0)*b)/determinante;
      *y = ((C-f3(x0,y0)+e*x0+f*y0)*a - (A-f1(x0,y0)+a*x0+b*y0)*e)/determinante;
      if (fabs((*x)*c + (*y)*d + f2(x0, y0) - B - c*x0 - d*y0) < epsilon)
	return 1;
    }
    else
    {
      determinante = f*c - d*e;
      if (fabs(determinante) > epsilon) {
	*x = ((B-f2(x0,y0)+c*x0+d*y0)*f - (C-f3(x0,y0)+e*x0+f*y0)*d)/determinante;
	*y = ((C-f3(x0,y0)+e*x0+f*y0)*c - (B-f2(x0,y0)+c*x0+d*y0)*e)/determinante;
	if (fabs((*x)*a + (*y)*b + f1(x0, y0) - A - a*x0 - b*y0) < epsilon)
	  return 1;
      }
    }
  }

  return 0;
}

/* ----------------------------------------------------------------------- */

void Fi(float (*f1)(float, float), float (*f2)(float, float),
	float (*f3)(float, float), float x0, float y0, float x, float y,
	float *A, float *B, float *C) {

  /* Calcula (*A, *B, *C) = f(x0, y0) + Jf(x0, y0)(x - x0, y - y0) */

  const float H = 1e-6;
  float a, b, c, d, e, f;

  a = (f1(x0 + H, y0) - f1(x0 - H, y0))/(2.0*H);
  b = (f1(x0, y0 + H) - f1(x0, y0 - H))/(2.0*H);
  c = (f2(x0 + H, y0) - f2(x0 - H, y0))/(2.0*H);
  d = (f2(x0, y0 + H) - f2(x0, y0 - H))/(2.0*H);
  e = (f3(x0 + H, y0) - f3(x0 - H, y0))/(2.0*H);
  f = (f3(x0, y0 + H) - f3(x0, y0 - H))/(2.0*H);

  *A = f1(x0, y0) + a*(x - x0) + b*(y - y0);
  *B = f2(x0, y0) + c*(x - x0) + d*(y - y0);
  *C = f3(x0, y0) + e*(x - x0) + f*(y - y0);
}

/* ----------------------------------------------------------------------- */

int CalculaP0Q0(float (*f1)(float, float),float (*f2)(float, float),
		 float (*f3)(float, float), float x0, float y0,
		 float X1, float Y1, float X2, float Y2,
		 float *P1, float *P2, float *P3) {

  /*  (1)                    (1)
     a    = (X1, Y1)        b    = (X2, Y2)
       0                     0
  */

  float v1, v2, v3, w1, w2, w3;
  const float H = 1e-6, erro = 1e-8;
  float produto_interno, N_w_2, a, b, c, d, e, f;

  a = (f1(x0 + H, y0) - f1(x0 - H, y0))/(2.0*H);
  b = (f1(x0, y0 + H) - f1(x0, y0 - H))/(2.0*H);
  c = (f2(x0 + H, y0) - f2(x0 - H, y0))/(2.0*H);
  d = (f2(x0, y0 + H) - f2(x0, y0 - H))/(2.0*H);
  e = (f3(x0 + H, y0) - f3(x0 - H, y0))/(2.0*H);
  f = (f3(x0, y0 + H) - f3(x0, y0 - H))/(2.0*H);

  Fi(f1, f2, f3, x0, y0, X1, Y1, &v1, &v2, &v3);

  w1 = a*X2 + b*Y2;
  w2 = c*X2 + d*Y2;
  w3 = e*X2 + f*Y2;
  N_w_2 = w1*w1 + w2*w2 + w3*w3;
  if (fabs(N_w_2) < erro) return 0;

  produto_interno = w1*(f1(x0,y0)-v1) + w2*(f2(x0,y0)-v2) + w3*(f3(x0,y0)-v3);
  *P1 = v1 + produto_interno/N_w_2*w1;
  *P2 = v2 + produto_interno/N_w_2*w2;
  *P3 = v3 + produto_interno/N_w_2*w3;
  return 1;
}

/* ----------------------------------------------------------------------- */

int CalculaR0(float (*f1)(float, float), float (*f2)(float, float),
	       float (*f3)(float, float), float x0, float y0,
	       float (*g1)(float, float), float (*g2)(float, float),
	       float (*g3)(float, float), float x1, float y1,
	       float *R1, float *R2, float *R3) {

  float X1, Y1, Z1, W1, X2, Y2, Z2, W2, P1, P2, P3, Q1, Q2, Q3;

  CalculaA0B0(f1, f2, f3, x0, y0, g1, g2, g3, x1, y1,
				&X1, &Y1, &Z1, &W1, &X2, &Y2, &Z2, &W2);

  if (!CalculaP0Q0(f1, f2, f3, x0, y0, X1, Y1, X2, Y2, &P1, &P2, &P3) ||
      !CalculaP0Q0(g1, g2, g3, x1, y1, Z1, W1, Z2, W2, &Q1, &Q2, &Q3))
    return 0;

  *R1 = (P1 + Q1)/2;
  *R2 = (P2 + Q2)/2;
  *R3 = (P3 + Q3)/2;
  return 1;
}

/* ----------------------------------------------------------------------- */

int CalculaProximoXn(float (*f1)(float, float), float (*f2)(float, float),
	       float (*f3)(float, float), float x0, float y0,
	       float (*g1)(float, float), float (*g2)(float, float),
	       float (*g3)(float, float), float x1, float y1,
	       float *X1, float *Y1, float *Z1, float *W1) {

  float R1, R2, R3;

  if (CalculaR0(f1, f2, f3, x0, y0, g1, g2, g3, x1, y1, &R1, &R2, &R3))
    if (FiInversa(f1, f2, f3, x0, y0, R1, R2, R3, X1, Y1) &&
      FiInversa(g1, g2, g3, x1, y1, R1, R2, R3, Z1, W1))
      return 1;
  return 0;
}

/* ----------------------------------------------------------------------- */

#define SQR(x) ((x)*(x))
#define DISTANCIA2(a, b, c, d, A, B, C, D) (sqrt(SQR(a - A) + \
				       SQR(b - B) + SQR(c - C) + SQR(d - D)))

int CalculaPontoDaIntersecao(float (*f1)(float,float), float (*f2)(float,float),
			  float (*f3)(float, float), float (*g1)(float, float),
			  float (*g2)(float, float), float (*g3)(float, float),
			  float *X0, float *Y0, float *X1, float *Y1,
			  float x0, float y0, float x1, float y1) {

  float dist;
  const float erro = 1e-6;
  int n_it = 0, MAX_IT = 50, n;
  const float epsilon = 1e-5;
  float fn0, fn1, fn2, gn0, gn1, gn2, t0, t1, t2;

  do {
   /***********/
   if (!VetorNormal(&fn0, &fn1, &fn2, f1, f2, f3, x0, y0)) return 0;
   if (!VetorNormal(&gn0, &gn1, &gn2, g1, g2, g3, x1, y1)) return 0;
   PROD_VET(t0, t1, t2, fn0, fn1, fn2, gn0, gn1, gn2);
   if (NORMA(t0, t1, t2) < epsilon) return 0;
   /***********/
   n = CalculaProximoXn(f1, f2, f3, x0, y0, g1, g2, g3, x1, y1, X0, Y0, X1, Y1);
   if (n_it++ >= MAX_IT) return 0;
   dist = DISTANCIA2(x0, y0, x1, y1, *X0, *Y0, *X1, *Y1);
   x0 = *X0; x1 = *X1; y0 = *Y0; y1 = *Y1;
  } while (n != 0 && dist > erro);
  if (n == 0) return 0;
  return n_it;
}

/* ----------------------------------------------------------------------- */

#define Norma(a, b) sqrt((a)*(a) + (b)*(b))

/* ----------------------------------------------------------------------- */

float CalculaLambda(float (*f1)(float, float), float (*f2)(float, float),
  float (*f3)(float, float), float x0, float y0, float B_estrela_1,
  float B_estrela_2, float (*g1)(float, float), float (*g2)(float, float),
  float (*g3)(float, float), float x1, float y1, float B_estrela_3,
						  float B_estrela_4) {

  float lambda;
  const float H = 1E-6, erro = 1E-6;
  float a, b, c, d, e, f, g, h, i, j, k, l, A, B, C, D, E, F;

/*
    Determina o lambda que satisfaz `a equacao

                                             
     a b                               g h               
     c d    B_estrela_1    =   lambda  i j   B_estrela_3 
     e f    B_estrela_2                k l   B_estrela_4 
                                                         

    onde {{a, b}, {c, d}, {e, f}}  e {{g, h}, {i, j}, {k, l}} sao as
    matrizes jacobianas de (f1, f2, f3)  e  (g1, g2, g3)  nos pontos
    (x0, y0) e (x1, y1).
*/

  a = (f1(x0 + H, y0) - f1(x0 - H, y0))/(2.0*H);
  b = (f1(x0, y0 + H) - f1(x0, y0 - H))/(2.0*H);
  c = (f2(x0 + H, y0) - f2(x0 - H, y0))/(2.0*H);
  d = (f2(x0, y0 + H) - f2(x0, y0 - H))/(2.0*H);
  e = (f3(x0 + H, y0) - f3(x0 - H, y0))/(2.0*H);
  f = (f3(x0, y0 + H) - f3(x0, y0 - H))/(2.0*H);

  g = (g1(x1 + H, y1) - g1(x1 - H, y1))/(2.0*H);
  h = (g1(x1, y1 + H) - g1(x1, y1 - H))/(2.0*H);
  i = (g2(x1 + H, y1) - g2(x1 - H, y1))/(2.0*H);
  j = (g2(x1, y1 + H) - g2(x1, y1 - H))/(2.0*H);
  k = (g3(x1 + H, y1) - g3(x1 - H, y1))/(2.0*H);
  l = (g3(x1, y1 + H) - g3(x1, y1 - H))/(2.0*H);

  A = a*B_estrela_1 + b*B_estrela_2;
  B = c*B_estrela_1 + d*B_estrela_2;
  C = e*B_estrela_1 + f*B_estrela_2;

  D = g*B_estrela_3 + h*B_estrela_4;
  E = i*B_estrela_3 + j*B_estrela_4;
  F = k*B_estrela_3 + l*B_estrela_4;

  if (fabs(A) > erro) lambda = D/A;
  else if (fabs(B) > erro) lambda = E/B;
  else if (fabs(C) > erro) lambda = F/C;
  if (fabs(D - lambda*A) < erro &&
      fabs(E - lambda*B) < erro &&
      fabs(F - lambda*C) < erro) return lambda;
  return 0;
}

/* ----------------------------------------------------------------------- */

int ProximoPontoDaIntersecao(float (*f1)(float,float), float (*f2)(float,float),
			  float (*f3)(float, float), float (*g1)(float, float),
			  float (*g2)(float, float), float (*g3)(float, float),
			  float *X0, float *Y0, float *X1, float *Y1,
			  float x0, float y0, float x1, float y1) {

  float lambda, auxX1, auxY1, X2, Y2, auxZ1, auxW1, Z2, W2;
  float B_estrela_1, B_estrela_2, B_estrela_3 , B_estrela_4;
  float  x_ini_0, y_ini_0, x_ini_1, y_ini_1;
  int n_it;

  CalculaA0B0(f1, f2, f3, x0, y0, g1, g2, g3, x1, y1, &auxX1, &auxY1, &auxZ1,
     &auxW1, &X2, &Y2, &Z2, &W2);

  B_estrela_1 = X2/Norma(X2, Y2);
  B_estrela_2 = Y2/Norma(X2, Y2);
  B_estrela_3 = Z2/Norma(Z2, W2);
  B_estrela_4 = W2/Norma(Z2, W2);

  lambda = CalculaLambda(f1, f2, f3, x0, y0, B_estrela_1, B_estrela_2,
			 g1, g2, g3, x1, y1, B_estrela_3, B_estrela_4);

  x_ini_0 = x0 + ksi*B_estrela_1;
  y_ini_0 = y0 + ksi*B_estrela_2;
  x_ini_1 = x1 + lambda*ksi*B_estrela_3;
  y_ini_1 = y1 + lambda*ksi*B_estrela_4;

  n_it = CalculaPontoDaIntersecao(f1, f2, f3, g1, g2, g3, X0, Y0, X1, Y1,
				x_ini_0, y_ini_0, x_ini_1, y_ini_1);
  return n_it;
}

/* ----------------------------------------------------------------------- */

int AnteriorPontoDaIntersecao(float (*f1)(float,float), float (*f2)(float,float),
			  float (*f3)(float, float), float (*g1)(float, float),
			  float (*g2)(float, float), float (*g3)(float, float),
			  float *X0, float *Y0, float *X1, float *Y1,
			  float x0, float y0, float x1, float y1) {

  float lambda, auxX1, auxY1, X2, Y2, auxZ1, auxW1, Z2, W2;
  float B_estrela_1, B_estrela_2, B_estrela_3 , B_estrela_4;
  float  x_ini_0, y_ini_0, x_ini_1, y_ini_1;
  int n_it;

  CalculaA0B0(f1, f2, f3, x0, y0, g1, g2, g3, x1, y1, &auxX1, &auxY1, &auxZ1,
     &auxW1, &X2, &Y2, &Z2, &W2);
  B_estrela_1 = X2/Norma(X2, Y2);
  B_estrela_2 = Y2/Norma(X2, Y2);
  B_estrela_3 = Z2/Norma(Z2, W2);
  B_estrela_4 = W2/Norma(Z2, W2);

  lambda = CalculaLambda(f1, f2, f3, x0, y0, B_estrela_1, B_estrela_2,
			 g1, g2, g3, x1, y1, B_estrela_3, B_estrela_4);

  x_ini_0 = x0 - ksi*B_estrela_1;
  y_ini_0 = y0 - ksi*B_estrela_2;
  x_ini_1 = x1 - lambda*ksi*B_estrela_3;
  y_ini_1 = y1 - lambda*ksi*B_estrela_4;

  n_it = CalculaPontoDaIntersecao(f1, f2, f3, g1, g2, g3, X0, Y0, X1, Y1,
				x_ini_0, y_ini_0, x_ini_1, y_ini_1);
  return n_it;
}

/* ----------------------------------------------------------------------- */

int PontoNaIntersecao(float (*f1)(float,float), float (*f2)(float,float),
			  float (*f3)(float, float), float (*g1)(float, float),
			  float (*g2)(float, float), float (*g3)(float, float),
			  float x0, float y0, float x1, float y1) {

  const float erro = 1e-7;

  return (fabs(f1(x0, y0) - g1(x1, y1)) < erro &&
	  fabs(f2(x0, y0) - g2(x1, y1)) < erro &&
	  fabs(f3(x0, y0) - g3(x1, y1)) < erro);
}

/* ----------------------------------------------------------------------- */

int SSI(float (*f1)(float, float), float (*f2)(float, float),
	float (*f3)(float, float), float (*g1)(float, float),
	float (*g2)(float, float), float (*g3)(float, float),
	float x0_ini, float y0_ini, float x0_min, float x0_max,
				    float y0_min, float y0_max,
	float x1_ini, float y1_ini, float x1_min, float x1_max,
				    float y1_min, float y1_max) {

  static unsigned quant = 0;
  int it;
  float x0, y0, x1, y1;

  quantidade_de_pontos = 0;
  it = CalculaPontoDaIntersecao(f1, f2, f3, g1, g2, g3, &x0, &y0, &x1, &y1,
				x0_ini, y0_ini, x1_ini, y1_ini);
  if (it == 0) return SPONTOINICIAL;

  do {
    x0_ini = x0; x1_ini = x1; y0_ini = y0; y1_ini = y1;
    if (!ProximoPontoDaIntersecao(f1, f2, f3, g1, g2, g3, &x0, &y0, &x1, &y1,
		x0_ini, y0_ini, x1_ini, y1_ini)) return SPROXIMOPONTO;
    if (x0 < x0_min || x0 > x0_max || y0 < y0_min || y0 > y0_max ||
      x1 < x1_min || x1 > x1_max || y1 < y1_min || y1 > y1_max)
      return FORAINTERVALO;
    if (PontoNaIntersecao(f1, f2, f3, g1, g2, g3, x0, y0, x1, y1)) {
    /* if (!VetorTangente(&t0,&t1,&t2,f1,f2,f3,x0,y0,g1,g2,g3,x1,y1,1))
	return VETORTANGENTE; */
      if (HouveErro) return OVERFLOW;
      if (!IncluiPonto(x0, y0)) return PONTOREPETIDO;
	DesenhaPonto(f1(x0, y0), f2(x0, y0), f3(x0, y0));
	quant_pontos++;
      quant++;
    }
  } while (quant < QUANT_MAX_PONTOS);

  if  (quant >= QUANT_MAX_PONTOS) return PONTOSDEMAIS;

  return 1;
}

/* ----------------------------------------------------------------------- */

int SSI2(float (*f1)(float, float), float (*f2)(float, float),
	float (*f3)(float, float), float (*g1)(float, float),
	float (*g2)(float, float), float (*g3)(float, float),
	float x0_ini, float y0_ini, float x0_min, float x0_max,
				    float y0_min, float y0_max,
	float x1_ini, float y1_ini, float x1_min, float x1_max,
				    float y1_min, float y1_max) {

  static unsigned quant = 0;
  int it;
  float x0, y0, x1, y1;

  quantidade_de_pontos = 0;
  it = CalculaPontoDaIntersecao(f1, f2, f3, g1, g2, g3, &x0, &y0, &x1, &y1,
				x0_ini, y0_ini, x1_ini, y1_ini);
  if (it == 0) return SPONTOINICIAL;

  do {
    x0_ini = x0; x1_ini = x1; y0_ini = y0; y1_ini = y1;
    if (!AnteriorPontoDaIntersecao(f1, f2, f3, g1, g2, g3, &x0, &y0, &x1, &y1,
		x0_ini, y0_ini, x1_ini, y1_ini)) return SPROXIMOPONTO;
    if (x0 < x0_min || x0 > x0_max || y0 < y0_min || y0 > y0_max ||
      x1 < x1_min || x1 > x1_max || y1 < y1_min || y1 > y1_max)
      return FORAINTERVALO;
    if (PontoNaIntersecao(f1, f2, f3, g1, g2, g3, x0, y0, x1, y1)) {
      if (HouveErro) return OVERFLOW;
      if (!IncluiPonto(x0, y0)) return PONTOREPETIDO;
      DesenhaPonto(f1(x0, y0), f2(x0, y0), f3(x0, y0));
	quant_pontos++;
      quant++;
    }
  } while (quant < QUANT_MAX_PONTOS);

  if  (quant >= QUANT_MAX_PONTOS) return PONTOSDEMAIS;
  return 1;
}

/* ----------------------------------------------------------------------- */

/*** FIM DE SSI.C ***/
